SystemOrganization addCategory: #'AL-Application-Core'!
SystemOrganization addCategory: #'AL-Application-Utilities'!

Object subclass: #ALAbstractLocator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALAbstractLocator methodsFor: 'public' stamp: 'cwp 10/8/2012 00:20'!
resourceForUrl: aPath
	self subclassResponsibility! !

!ALAbstractLocator methodsFor: 'public' stamp: 'cwp 10/8/2012 00:19'!
urlForResource: aResource
	self subclassResponsibility! !

ALAbstractLocator subclass: #ALRestfulLocator
	instanceVariableNames: 'strategy urls resources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALRestfulLocator class methodsFor: 'instance creation' stamp: 'cwp 8/4/2012 22:53'!
digest
	^ self strategy: ALDigestUrlStrategy new! !

!ALRestfulLocator class methodsFor: 'instance creation' stamp: 'cwp 10/9/2012 00:08'!
new
	^ self digest! !

!ALRestfulLocator class methodsFor: 'instance creation' stamp: 'cwp 10/14/2012 01:29'!
random
	^ self strategy: ALRandomUrlStrategy new! !

!ALRestfulLocator class methodsFor: 'instance creation' stamp: 'cwp 10/14/2012 02:12'!
sequential
	^ self strategy: ALSequentialUrlStrategy new! !

!ALRestfulLocator class methodsFor: 'instance creation' stamp: 'cwp 8/4/2012 22:52'!
strategy: aUrlStrategy
	^ self basicNew initializeWithStrategy: aUrlStrategy! !

!ALRestfulLocator methodsFor: 'initialize-release' stamp: 'cwp 12/13/2012 20:30'!
at: aPath alias: aResource
	resources at: aPath path put: aResource.! !

!ALRestfulLocator methodsFor: 'initialize-release' stamp: 'cwp 12/13/2012 20:30'!
at: aPath put: aResource
	resources at: aPath put: aResource.
	urls at: (self keyForResource: aResource) put: aPath! !

!ALRestfulLocator methodsFor: 'initialize-release' stamp: 'cwp 12/13/2012 20:30'!
initializeWithStrategy: aUrlStrategy
	self initialize.
	urls := Dictionary new.
	resources := Dictionary new.
	strategy := aUrlStrategy! !

!ALRestfulLocator methodsFor: 'private' stamp: 'cwp 10/14/2012 00:46'!
keyForResource: aResource
	^ aResource serialize digest! !

!ALRestfulLocator methodsFor: 'public' stamp: 'cwp 12/13/2012 20:30'!
resourceForUrl: aUrl
	^ resources 
		at: aUrl path 
		ifAbsent: [ALNotFound signal: aUrl printString]
		
			! !

!ALRestfulLocator methodsFor: 'serializing' stamp: 'cwp 8/4/2012 23:03'!
serializeWith: aSerializer
	aSerializer serializeExternally: self  ! !

!ALRestfulLocator methodsFor: 'public' stamp: 'cwp 12/13/2012 20:30'!
urlForResource: aResource
	| key |
	key := self keyForResource: aResource.
	^ urls at: key ifAbsentPut: 
		[| segment |
		segment := strategy printKey: key.
		resources at: ALPath / segment put: aResource.
		ALUrl / segment]! !

Object subclass: #ALApplication
	instanceVariableNames: 'locator factories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALApplication class methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 01:37'!
new
	^ self withLocator: (ALRestfulLocator random)! !

!ALApplication class methodsFor: 'as yet unclassified' stamp: 'cwp 3/7/2011 23:08'!
withLocator: aLocator
	^ self basicNew
		initializeWithLocator: aLocator;
		yourself! !

!ALApplication methodsFor: 'initialize-release' stamp: 'cwp 12/2/2012 19:01'!
addFactory: aBlock
	factories add: aBlock! !

!ALApplication methodsFor: 'api' stamp: 'cwp 12/26/2012 09:01'!
createRequestHandler
	| relay |
	relay := ALTerminalRelay locator: locator.
	factories reverseDo: [:ea | relay := ea value: relay].
	^ relay! !

!ALApplication methodsFor: 'initialize-release' stamp: 'cwp 11/30/2012 20:31'!
initializeFactories
	! !

!ALApplication methodsFor: 'initialize-release' stamp: 'cwp 9/27/2011 16:20'!
initializeLocator! !

!ALApplication methodsFor: 'initialize-release' stamp: 'cwp 11/30/2012 20:31'!
initializeWithLocator: aLocator
	locator := aLocator.
	factories := OrderedCollection new.
	self initializeLocator.
	self initializeFactories.
	! !

Object subclass: #ALDirectoryScanner
	instanceVariableNames: 'locator guide ignore root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Utilities'!

!ALDirectoryScanner class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:34'!
locator: aLocator
	^ self basicNew initializeWithLocator: aLocator  ! !

!ALDirectoryScanner class methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:46'!
scan: aReference into: aLocator
	(self locator: aLocator) scan: aReference.
	^ aLocator! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:37'!
initializeWithLocator: aLocator
	locator := aLocator.
	guide := FSPreorderGuide for: self.! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:54'!
scan: aReference
	root := aReference resolve.
	guide show: root! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/16/2011 23:53'!
visitDirectory: anEntry
	| reference |
	reference := anEntry reference.
	(reference basename first = $.) ifTrue: [ignore := reference].
	! !

!ALDirectoryScanner methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2011 00:00'!
visitFile: anEntry
	| path reference |
	reference := anEntry reference.
	ignore ifNotNil: [(ignore contains: reference) ifTrue: [^ self]].
	ignore := nil.
	(reference basename first = $.) ifFalse:
		[path := ALPath withAll: (reference relativeTo: root).
		locator at: path put: (ALFileResource on: reference)]! !

Object subclass: #ALResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

ALResource subclass: #ALCallbackResource
	instanceVariableNames: 'resource callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALCallbackResource class methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2011 22:19'!
resource: aResource callback: aValuable
	^ self basicNew initializeWithResource: aResource callback: aValuable! !

!ALCallbackResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2011 22:30'!
applyRequest: aRequest
	^ self value! !

!ALCallbackResource methodsFor: 'public' stamp: 'cwp 10/8/2012 00:19'!
handleGet: aRequest locator: aLocator
	| path |
	path := aLocator urlForResource: (self applyRequest: aRequest).
	^ ALResponse seeOther: path! !

!ALCallbackResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/5/2011 22:20'!
initializeWithResource: aResource callback: aValuable
	self initialize.
	resource := aResource.
	callback := aValuable.! !

!ALCallbackResource methodsFor: 'as yet unclassified' stamp: 'cwp 8/21/2011 22:30'!
value
	callback value.
	^ resource! !

ALResource subclass: #ALFileResource
	instanceVariableNames: 'reference'
	classVariableNames: 'MimeTypes'
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALFileResource class methodsFor: 'as yet unclassified' stamp: 'cwp 11/17/2012 13:39'!
initialize
	MimeTypes := Dictionary new
		at: 'css' put: (ALContentType type: 'text' subtype: 'css');
		at: 'html' put: (ALContentType type: 'text' subtype: 'html');
		at: 'ico' put: ALContentType favicon;
		at: 'js' put: (ALContentType type: 'application' subtype: 'javascript');
		at: 'less' put: (ALContentType type: 'text' subtype: 'x-lesscss');
		at: 'png' put: ALContentType png;
		yourself! !

!ALFileResource class methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2011 23:17'!
on: aReference
	^ self new initializeWithReference: aReference! !

!ALFileResource methodsFor: 'comparing' stamp: 'cwp 3/11/2011 23:18'!
= other 
	^ self species = other species and: [self reference = other reference]! !

!ALFileResource methodsFor: 'private' stamp: 'cwp 12/6/2012 15:11'!
cachedResponse: aRequest
	| cached modified |
	cached := aRequest ifModifiedSince.
	modified := reference entry modification. 
	^ modified > cached 
		ifTrue: [self fullResponse]
		ifFalse: [ALResponse status: 304 reason: 'Not modified']! !

!ALFileResource methodsFor: 'public' stamp: 'cwp 11/4/2012 22:18'!
contentType
	^ MimeTypes 
		at: reference extension
		ifAbsent: [ALContentType octets]! !

!ALFileResource methodsFor: 'private' stamp: 'cwp 12/6/2012 16:49'!
fullResponse
	| body entry |
	entry := reference entry.
	body := ALEntity callback: 
		[:out || in |
		in := reference reading.
		[out write: in] ensure: [in close]].
	body contentType: self contentType.
	body contentLength: entry size.
	body lastModified: entry modification.
	^ ALResponse status: 200 reason: 'OK' body: body! !

!ALFileResource methodsFor: 'public' stamp: 'cwp 12/6/2012 16:49'!
handleGet: aRequest locator: aLocator
	reference exists ifFalse: [ ALNotFound signal ].
	^ aRequest hasIfModifiedSince
		ifTrue: [ self cachedResponse: aRequest ]
		ifFalse: [ self fullResponse ]! !

!ALFileResource methodsFor: 'comparing' stamp: 'cwp 3/11/2011 23:18'!
hash
	^ reference hash! !

!ALFileResource methodsFor: 'initialize-release' stamp: 'cwp 3/11/2011 23:18'!
initializeWithReference: aReference
	reference := aReference ! !

!ALFileResource methodsFor: 'accessing' stamp: 'cwp 3/11/2011 23:18'!
reference
	^ reference! !

!ALResource methodsFor: 'converting' stamp: 'cwp 3/5/2012 21:22'!
asResource
	^ self! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/1/2011 16:41'!
handleConnect: aRequest locator: aLocator
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/1/2011 16:41'!
handleDelete: aRequest locator: aLocator
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/1/2011 16:41'!
handleGet: aRequest locator: aLocator
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/1/2011 16:41'!
handleHead: aRequest locator: aLocator
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/1/2011 16:41'!
handleOptions: aRequest locator: aLocator
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/6/2011 21:22'!
handlePost: aRequest locator: aLocator
	aRequest readEntityWith: [:in | in rest].  
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/6/2011 21:22'!
handlePut: aRequest locator: aLocator
	aRequest readEntityWith: [:in | in rest].  
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'public' stamp: 'cwp 10/1/2011 16:24'!
handleRequest: aRequest locator: aLocator
	aRequest isMethodConnect ifTrue: [^ self handleConnect: aRequest locator: aLocator].
	aRequest isMethodDelete ifTrue: [^ self handleDelete: aRequest locator: aLocator].
	aRequest isMethodGet ifTrue: [^ self handleGet: aRequest locator: aLocator].
	aRequest isMethodHead ifTrue: [^ self handleHead: aLocator locator: aLocator].
	aRequest isMethodOptions ifTrue: [self handleOptions: aRequest locator: aLocator].
	aRequest isMethodPost ifTrue: [^ self handlePost: aRequest locator: aLocator].
	aRequest isMethodPut ifTrue: [^ self handlePut: aRequest locator: aLocator].
	aRequest isMethodTrace ifTrue: [^ self handleTrace: aRequest locator: aLocator].
	self methodNotAllowed: aRequest method.! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/1/2011 16:41'!
handleTrace: aRequest locator: aLocator
	^ self methodNotAllowed: aRequest  ! !

!ALResource methodsFor: 'private' stamp: 'cwp 10/8/2012 00:24'!
methodNotAllowed: aRequest
	^ ALResponse
		status: 405
		reason: 'Method not allowed'
		details: 'The method ', aRequest method, ' is not allowed for ', aRequest url asString! !

Object subclass: #ALUrlStrategy
	instanceVariableNames: ''
	classVariableNames: 'Alphabet'
	poolDictionaries: ''
	category: 'AL-Application-Core'!

ALUrlStrategy subclass: #ALDigestUrlStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALDigestUrlStrategy methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 01:21'!
printKey: aByteArray
	| out in |
	out := String new writing.
	in := aByteArray reading.
	1 to: 6 do: [ :ignore | 
		| byte bits |
		byte := in get.
		bits := byte bitShift: -2.
		out put: (Alphabet at: bits + 1).
		bits := (byte bitAnd: 2r00000011) bitShift: 4.
		byte := in get.
		bits := bits bitOr: (byte bitShift: -4).
		out put: (Alphabet at: bits + 1).
		bits := (byte bitAnd: 2r00001111) bitShift: 2.
		byte := in get.
		bits := bits bitOr: (byte bitShift: -6).
		out put: (Alphabet at: bits + 1).
		bits := byte bitAnd: 2r00111111.
		out put: (Alphabet at: bits + 1) ].
	^ out conclusion! !

ALUrlStrategy subclass: #ALRandomUrlStrategy
	instanceVariableNames: 'in'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALRandomUrlStrategy methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 01:25'!
initialize
	in := Random new reading.
	! !

!ALRandomUrlStrategy methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 01:30'!
printKey: aByteArray
	| index out |
	out := String new writing.
	1 to: 24 do: 
		[:ignore | 
		index := (in get * 64) truncated + 1.
		out put: (Alphabet at: index)].
	^ out conclusion! !

ALUrlStrategy subclass: #ALSequentialUrlStrategy
	instanceVariableNames: 'count printer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Application-Core'!

!ALSequentialUrlStrategy methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 02:08'!
initialize
	count := -1.
	printer := XTNumberPrinter new.
	printer alphabet: Alphabet.
	printer base: 64.
	! !

!ALSequentialUrlStrategy methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 02:09'!
printKey: aByteArray
	| out |
	count := count + 1.
	out := String new writing.
	printer print: count on: out.
	^ out conclusion! !

!ALUrlStrategy class methodsFor: 'as yet unclassified' stamp: 'cwp 11/29/2012 16:51'!
alphabet
	^ Alphabet! !

!ALUrlStrategy class methodsFor: 'as yet unclassified' stamp: 'cwp 10/14/2012 01:35'!
initialize
	Alphabet := '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-_'! !
ALFileResource initialize!
ALUrlStrategy initialize!
